<?php
/** 
* 
* @package Minimum Topic to Read Message
* @copyright (c) 2015 BruninoIt
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2 
* 
*/ 
namespace bruninoit\mtrm\event;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
class listener implements EventSubscriberInterface
{
	/** @var \phpbb\config\config */	
	protected $config;
	/** @var \phpbb\db\driver\driver_interface */
	protected $db;
	/** @var \phpbb\template\template */
	protected $template;
	/** @var \phpbb\auth\auth */
	protected $auth;
	/** @var \phpbb\user */
	protected $user;
	protected $root_path;
	
	protected $phpEx;
/** 
 	* Constructor 
 	* 
 	* @param \phpbb\config\config   		$config             	 Config object 
 	* @param \phpbb\db\driver\driver_interface      $db        	 	 DB object 
 	* @param \phpbb\template\template    		$template  	 	 Template object 
 	* @param \phpbb\auth\auth      			$auth           	 Auth object 
 	* @param \phpbb\use		     		$user           	 User object 
 	* @param	                		$root_path          	 Root Path object 
 	* @param                  	     		$phpEx          	 phpEx object 
 	* @return \staffit\toptentopics\event\listener 
 	* @access public 
 	*/ 
public function __construct(\phpbb\config\config $config, \phpbb\db\driver\driver_interface $db, \phpbb\template\template $template, \phpbb\auth\auth $auth, \phpbb\user $user, $root_path, $phpEx) 
{
   $this->config = $config;
   $this->db = $db;
   $this->template = $template; 
   $this->auth = $auth;
   $this->user = $user;
   $this->root_path = $root_path;
   $this->phpEx   = $phpEx ;
}
/** 
 	* Assign functions defined in this class to event listeners in the core 
 	* 
 	* @return array 
 	* @static 
 	* @access public 
 	*/ 
static public function getSubscribedEvents()	
{
return array(			
'core.user_setup'						=> 'setup',
'core.viewtopic_modify_post_row' => 'viewtopic_add',
'core.modify_posting_auth'=> 'pauth',
'core.posting_modify_template_vars' => 'template'
);	
}
public function setup($event)	{	
//language start
$lang_set_ext = $event['lang_set_ext'];
		$lang_set_ext[] = array(
			'ext_name' => 'bruninoit/mtrm',
			'lang_set' => 'common',
		);
		$event['lang_set_ext'] = $lang_set_ext;
}
public function template($event)
{
/*
cancel, draft_id, error, form_enctype, forum_id, load, message_parser, mode, moderators, page_data, page_title, post_data, post_id, preview, refresh, s_action, s_hidden_fields, s_topic_icons, save, submit, topic_id
*/

$uid = $this->user->data['user_id'];
$q = $this->db->sql_query("SELECT count(topic_id) as count FROM ".TOPICS_TABLE." WHERE topic_poster=$uid");
$r = $this->db->sql_fetchrow($q);
$ut = $r['count'];

$topic_id = $event['topic_id'];
$qa = $this->db->sql_query("SELECT post_text FROM ".POSTS_TABLE." WHERE topic_id=$topic_id");
while($r = $this->db->sql_fetchrow($qa))
{
$message = $r['post_text'];
if(strpos($message,"limit]"))
{
preg_match_all("#\[limit=(.*?)\]#", $message, $atopics);
if($atopics[1][0])
{
foreach($atopics[1] as $topics)
{
if($ut < $topics)
{
$error = 1;
}
}
}
}
}
if($error)
{
$event['mode'] = "ahahahahaha";
}
//var_dump($event['page_data']);
}
public function pauth($event)
{
/*
draft_id, error, forum_id, is_authed, lastclick, load, mode, post_id, preview, refresh, save, submit, topic_id
*/
$post_id = $event['post_id'];
$mode = $event['mode'];
//echo $post_id;
if($mode=="quote" and $post_id)
{
$error = 0;
$uid = $this->user->data['user_id'];
$q = $this->db->sql_query("SELECT count(topic_id) as count FROM ".TOPICS_TABLE." WHERE topic_poster=$uid");
$r = $this->db->sql_fetchrow($q);
$ut = $r['count'];


$qa = $this->db->sql_query("SELECT post_text FROM ".POSTS_TABLE." WHERE post_id=$post_id");
$ra = $this->db->sql_fetchrow($qa);
$message = $ra['post_text'];

if(strpos($message,"limit]"))
{
preg_match_all("#\[limit=(.*?)\]#", $message, $atopics);
if($atopics[1][0])
{
foreach($atopics[1] as $topics)
{
if($ut < $topics)
{
$error = 1;
}
}
}
}
}
if($error)
{
trigger_error('NO_PERMISSION');
}
}
public function viewtopic_add($event)	
{
$rowmessage=$event['post_row'];
$message=$rowmessage['MESSAGE'];
if(strpos($message,"limit]"))
{

$uid = $this->user->data['user_id'];
$q = $this->db->sql_query("SELECT count(topic_id) as count FROM ".TOPICS_TABLE." WHERE topic_poster=$uid");
$r = $this->db->sql_fetchrow($q);
$ut = $r['count'];

preg_match_all("#\[limit=(.*?)\]#", $message, $atopics);
if($atopics[1][0])
{
foreach($atopics[1] as $topics)
{
$lang=sprintf($this->user->lang['NOT_ENOUGH'], $topics, $ut);
preg_match_all("#\[limit=$topics\](.*?)\[/limit\]#", $message, $amessage);

if($amessage[1][0])
{
foreach($amessage[1] as $msg)
{
if($ut < $topics)
{
$message = str_replace("[limit=$topics]$msg", $lang, $message);
}
$message = str_replace("[limit=$topics]", "", $message);
}
}
}
}
}

$message = str_replace("[/limit]","", $message);
$rowmessage['MESSAGE'] = $message;
$event['post_row'] = $rowmessage;
}
}
